import "Turbine.Gameplay";

CoolDownManager = class();

-- cool down categories
CoolDownCategory = {};
CoolDownCategory.MoraleCoolDown = "morale";
CoolDownCategory.PowerCoolDown = "power";
CoolDownCategory.DiseaseCoolDown = "disease";
CoolDownCategory.FearCoolDown = "fear";
CoolDownCategory.PoisonCoolDown = "poison";
CoolDownCategory.WoundCoolDown = "wound";

function CoolDownManager:Constructor()
    -- listeners
    self.listeners = {};
    
    -- create the pots
    self.activePots = {};
    self.pots = 
    {
        Pot(L["Morale"], CoolDownCategory.MoraleCoolDown, 120, {L["Concentrated Essence of Athelas"], L["Distilled Athelas Essence"], L["Distilled Athelas Extract"], L["Elixir of Twice Purified Athelas"], L["Enhanced Essence of Athelas"], L["Greater Athelas Essence"], L["Greater Athelas Extract"], L["Infused Athelas Essence"], L["Infused Athelas Extract"], L["Lesser Athelas Essence"], L["Lesser Athelas Extract"], L["Potent Athelas Essence"], L["Pure Athelas Essence"], L["Pure Athelas Extract"], L["Refined Athelas Essence"], L["Refined Athelas Extract"], L["Simple Athelas Essence"], L["Simple Athelas Extract"], L["Steeped Athelas Essence"]}),
        Pot(L["Morale (Store)"], CoolDownCategory.MoraleCoolDown, 20, {L["Lesser Draught of Morale"], L["Minor Draught of Morale"], L["Moderate Draught of Morale"], L["Draught of Morale"], L["Greater Draught of Morale"], L["Major Draught of Morale"], L["Superior Draught of Morale"]}),
        Pot(L["Power"], CoolDownCategory.PowerCoolDown, 120, {L["Distilled Celebrant Ointment"], L["Distilled Celebrant Salve"], L["Elixir of Twice Purified Celebrant"], L["Greater Celebrant Ointment"], L["Greater Celebrant Salve"], L["Infused Celebrant Ointment"], L["Infused Celebrant Salve"], L["Lesser Celebrant Ointment"], L["Lesser Celebrant Salve"], L["Potent Celebrant Salve"], L["Pure Celebrant Ointment"], L["Pure Celebrant Salve"], L["Refined Celebrant Ointment"], L["Refined Celebrant Salve"], L["Simple Celebrant Ointment"], L["Simple Celebrant Salve"], L["Steeped Celebrant Salve"]}),
        Pot(L["Power (Store)"], CoolDownCategory.PowerCoolDown, 20, {L["Lesser Draught of Power"], L["Minor Draught of Power"], L["Moderate Draught of Power"], L["Draught of Power"], L["Greater Draught of Power"], L["Major Draught of Power"], L["Superior Draught of Power"]}),
        Pot(L["Disease"], CoolDownCategory.DiseaseCoolDown, 30, {L["Brewed Flask of Lhinestad"], L["Brewed Salve of Lhinestad"], L["Distilled Lhinestad Draught"], L["Distilled Lhinestad Salve"], L["Flask of Lhinestad"], L["Greater Lhinestad Draught"], L["Greater Lhinestad Salve"], L["Infused Lhinestad Draught"], L["Infused Lhinestad Salve"], L["Lesser Lhinestad Draught"], L["Lesser Lhinestad Salve"], L["Pure Flask of Lhinestad"], L["Pure Salve of Lhinestad"], L["Refined Lhinestad Draught"], L["Refined Lhinestad Salve"], L["Salve of Lhinestad"], L["Simple Lhinestad Draught"], L["Simple Lhinestad Salve"], L["Steeped Lhinestad Draught"]}),
        Pot(L["Disease (Store)"], CoolDownCategory.DiseaseCoolDown, 30, {L["Lesser Disease Remedy"], L["Minor Disease Remedy"], L["Moderate Disease Remedy"], L["Disease Remedy"], L["Greater Disease Remedy"], L["Major Disease Remedy"], L["Superior Disease Remedy"]}),
        Pot(L["Fear"], CoolDownCategory.FearCoolDown, 30, {L["Brewed Flask of Conhuith"], L["Brewed Salve of Conhuith"], L["Distilled Conhuith Draught"], L["Distilled Conhuith Salve"], L["Flask of Conhuith"], L["Greater Conhuith Draught"], L["Greater Conhuith Salve"], L["Infused Conhuith Draught"], L["Infused Conhuith Salve"], L["Lesser Conhuith Draught"], L["Lesser Conhuith Salve"], L["Pure Flask of Conhuith"], L["Pure Salve of Conhuith"], L["Refined Conhuith Draught"], L["Refined Conhuith Salve"], L["Salve of Conhuith"], L["Simple Conhuith Draught"], L["Simple Conhuith Salve"], L["Steeped Conhuith Draught"]}),
        Pot(L["Fear (Store)"], CoolDownCategory.FearCoolDown, 30, {L["Lesser Fear Remedy"], L["Minor Fear Remedy"], L["Moderate Fear Remedy"], L["Fear Remedy"], L["Greater Fear Remedy"], L["Major Fear Remedy"], L["Superior Fear Remedy"]}),
        Pot(L["Poison"], CoolDownCategory.PoisonCoolDown, 30, {L["Brewed Milkthistle Draught"], L["Brewed Milkthistle Salve"], L["Distilled Milkthistle Draught"], L["Distilled Milkthistle Salve"], L["Greater Milkthistle Draught"], L["Greater Milkthistle Salve"], L["Infused Milkthistle Draught"], L["Infused Milkthistle Salve"], L["Lesser Milkthistle Draught"], L["Lesser Milkthistle Salve"], L["Milkthistle Draught"], L["Milkthistle Salve"], L["Pure Milkthistle Draught"], L["Pure Milkthistle Salve"], L["Refined Milkthistle Draught"], L["Refined Milkthistle Salve"], L["Simple Milkthistle Draught"], L["Simple Milkthistle Salve"], L["Steeped Milkthistle Draught"]}),
        Pot(L["Poison (Store)"], CoolDownCategory.PoisonCoolDown, 30, {L["Lesser Poison Remedy"], L["Minor Poison Remedy"], L["Moderate Poison Remedy"], L["Poison Remedy"], L["Greater Poison Remedy"], L["Major Poison Remedy"], L["Superior Poison Remedy"]}),
        Pot(L["Wound"], CoolDownCategory.WoundCoolDown, 30, {L["Brewed Healing Draught"], L["Brewed Healing Salve"], L["Distilled Healing Draught"], L["Distilled Healing Salve"], L["Greater Healing Draught"], L["Greater Healing Salve"], L["Healing Draught"], L["Healing Salve"], L["Infused Healing Draught"], L["Infused Healing Salve"], L["Lesser Healing Draught"], L["Lesser Healing Salve"], L["Pure Healing Draught"], L["Pure Healing Salve"], L["Refined Healing Draught"], L["Refined Healing Salve"], L["Simple Healing Draught"], L["Simple Healing Salve"], L["Steeped Healing Draught"]}),
        Pot(L["Wound (Store)"], CoolDownCategory.WoundCoolDown, 30, {L["Lesser Wound Remedy"], L["Minor Wound Remedy"], L["Moderate Wound Remedy"], L["Wound Remedy"], L["Greater Wound Remedy"], L["Major Wound Remedy"], L["Superior Wound Remedy"]}),
    };
    
    -- list of the backpack items
    self.items = {};
    
    -- hack control to get update events, remove when we can get updates without being a control
    self.update = Turbine.UI.Control();
    self.update:SetVisible(false);
    self.update:SetWantsUpdates(false);
    self.update.Update = function(sender, args)
        self:ProcessUpdate();
    end
    
    -- process the backpack
    self.backpack = Turbine.Gameplay.LocalPlayer():GetBackpack();
    local i;
    for i = 1, self.backpack:GetSize() do
        self:AddItem(i);
    end

    self.backpack.ItemAdded = function(sender, args)
        self:AddItem(args.Index);
    end

    self.backpack.ItemRemoved = function(sender, args)
        self:RemoveItem(args.Index);
    end
    
    self.backpack.ItemMoved = function(sender, args)
        self:SwapItems(args.OldIndex, args.NewIndex);
    end
end

function CoolDownManager:AddItem(index)
    local item = self.backpack:GetItem(index);
    self.items[index] = item;
    if (item == nil) then
        return;
    end
    
    local name = item:GetName();
    local i;
    for i = 1, table.getn(self.pots) do
        local pot = self.pots[i];
        if (pot:IsMatch(name)) then
            local quantity = item:GetQuantity();
            item.QuantityChanged = function(sender, args)
                local newQuantity = sender:GetQuantity();
                if ((quantity - 1) == newQuantity) then
                    pot:Start();
                    self:AddPot(pot);
                end
                quantity = newQuantity;
            end
            break;
        end
    end
end

function CoolDownManager:RemoveItem(index)
    local item = self.items[index];
    self.items[index] = nil;
    if (item ~= nil and item.QuantityChanged ~= nil) then
        item.QuantityChanged = nil;
    end
end

function CoolDownManager:SwapItems(oldIndex, newIndex)
    local old = self.backpack:GetItem(oldIndex);
    local new = self.backpack:GetItem(newIndex);
    self.items[oldIndex] = old;
    self.items[newIndex] = new;
end

function CoolDownManager:ProcessUpdate()
    local gameTime = Turbine.Engine.GetGameTime();
    local remove = {};
    local i;
    for i = 1, table.getn(self.activePots) do
        local elapsedTime = gameTime - self.activePots[i].startTime;
        if (elapsedTime > self.activePots[i].duration) then
            table.insert(remove, self.activePots[i]);
        end
    end
    
    for i = 1, table.getn(remove) do
        self:RemovePot(remove[i]);
    end
end

function CoolDownManager:AddListener(listener)
    -- make sure it isn't in the list already
    self:RemoveListener(listener);
    table.insert(self.listeners, listener);
end

function CoolDownManager:RemoveListener(listener)
    local i;
    for i = 1, table.getn(self.listeners) do
        if (self.listeners[i] == listener) then
            table.remove(self.listeners, i);
            break;
        end
    end
end

function CoolDownManager:GetPots()
    return self.activePots;
end

function CoolDownManager:AddPot(pot)
    table.insert(self.activePots, pot);
    local i;
    for i = 1, table.getn(self.listeners) do
        if (type(self.listeners[i].PotAdded) == "function") then
            self.listeners[i]:PotAdded(pot);
        end
    end
    self.update:SetWantsUpdates(true);
end

function CoolDownManager:RemovePot(pot)
    for i = 1, table.getn(self.activePots) do
        if (self.activePots[i] == pot) then
            table.remove(self.activePots, i);
            break;
        end
    end

    for i = 1, table.getn(self.listeners) do
        if (type(self.listeners[i].PotRemoved) == "function") then
            self.listeners[i]:PotRemoved(pot);
        end
    end
    self.update:SetWantsUpdates(table.getn(self.activePots) > 0);
end

-- define a global instance
CoolDownManager.instance = CoolDownManager();
